/*===========================================================================
	AUDIO.C

	interface avec carte son sous windows
	============================================================================*/


#include<windows.h>
#include <mmsystem.h> 
#include <stdio.h>

int impuls_detect = 100;

/*===========================================================================
	analog acquisition Windows)
	============================================================================*/
static int  audio_acq(float *a,long nval);
static int  audio_acq(float *a,long nval)
	/*************************************************************/
{ 
	static int inited=0, nchanels;
	static WAVEFORMATEX      waveformt;
	static WAVEHDR	      waveheaderIN;
	static HWAVEIN      handleIN;
	short	* wReadPtr; /* en mode 16 bits*/
	UINT err;
	int i,n;


	if(!inited){
		inited=1;

		n =waveInGetNumDevs();
		if(!n){printf("no audio card detected\n"); return 1;}
		//waveInGetDevCaps(FIRST_DRIVER,&Caps,sizeof(Caps));
		nchanels=1;
		/*load pcm wave format*/
		waveformt.wBitsPerSample=16;
		waveformt.wFormatTag=WAVE_FORMAT_PCM;
		waveformt.nChannels=nchanels;
		waveformt.nSamplesPerSec = 44100;
		waveformt.nBlockAlign=nchanels*2;
		waveformt.nAvgBytesPerSec = waveformt.nBlockAlign*waveformt.nSamplesPerSec;
		waveformt.cbSize=0;
		/*open driver WAVE IN */
		err=waveInOpen (&handleIN ,WAVE_MAPPER/*FIRST_DRIVER*/,
				&waveformt,0L ,0L,CALLBACK_NULL);
		if(err) return 100+err;

		/*{ HMIXER mixerh;
			err= mixerOpen(&mixerh,(UINT)handleIN,NULL,0,MIXER_OBJECTF_HWAVEIN);
			if(err) return;
			} */

		waveheaderIN.lpData=malloc(nval*4);
		waveheaderIN.dwBufferLength=nval*2;
		waveheaderIN.dwBytesRecorded=0;
		waveheaderIN.dwUser=0;
		waveheaderIN.dwFlags=0;
		err=waveInPrepareHeader(handleIN,&waveheaderIN,sizeof(waveheaderIN));
		if(err) return 7;
		err=waveInAddBuffer(handleIN,&waveheaderIN,sizeof(waveheaderIN));
		if(err) return 8;
		/*Start acq*/
		if(waveInStart(handleIN)) return 9;
	}
	if((waveheaderIN.dwFlags & WHDR_DONE)){
		wReadPtr=(short*)waveheaderIN.lpData;
		for(i=0;i<nval;i++){*a=(float)*wReadPtr; *wReadPtr=0 ;wReadPtr++;a++;}
		waveheaderIN.dwBytesRecorded=0;
		waveInReset( handleIN);
		waveInAddBuffer(handleIN,&waveheaderIN,sizeof(waveheaderIN));
		waveInStart(handleIN);
		return 0;
	}
	else return (-1);
}
#define NVAL 2000
static int get_data(float *values,int *nvalues)
{
	float x, px, max, min, moy;
	int imp;
	int err, nval = NVAL;
	int i, chanel;
	float time, dt;
	float sig [NVAL];

	err=audio_acq(sig,nval);
	if(err==0){
		max= -100000;
		min=  100000;
		for(i=0;i<nval;i++){
			x = sig[i];
			if (x>max) max=x;
			if (x<min) min=x;
		}
		moy = (max+min)/2;
		//moy = (2*max+min)/3;
		x=0;
		chanel=-1; time = 0;
		for(i=0;i<nval;i++){
			time++;
			if (time > impuls_detect){
				if (chanel < 0) chanel=0; //start
				if(chanel>0) break;//end
			}
			px=x;
			x = sig[i];
			if((x>moy) && (px<moy) ) imp = 1; else imp = 0;
			if(imp){
				dt = (moy-px)/(x-px);
				if (chanel>=0){
					if(chanel>0) {
						values[chanel-1]=(time+dt)/44.1-1.5;
					}
					chanel ++;
					if(chanel>10) break;
				}
				time = -dt;
			}
		}
	}
	else if(err>0) printf("error in audio device\n");
	*nvalues=chanel-1;
	return !err;
}
int get_data_from_audio_interface(float *values){
	static float vals[11];
	static nvals=0;
	int i,n;
	if(get_data(vals,&n)){
		for(i=0;i<11;i++)values[i]=vals[i];
		nvals = n;
	}
	return nvals;
}
#ifdef TEST_AUDIO
main(){
	float values[11];
	int i;
	do{
		if(get_data(values)) {
			for(i=0;i<4;i++) printf(" %2d:%+5.3f ",i,values[i]);
			printf("\n");
		}
		Sleep(60L);
	}while(1);
}
#endif

//mixer and volume ???

